-- globals
game = LuaGame(Game)
party = LuaParty(Party)
quests = LuaQuests(Quests)

--[[
	General
]]--

function isAvailable ()
	if quests:isQuestCompleted("gettingstarted") then
		return true
	else
		return false
	end
end

function getSource ()
	return "merchant"
end

function getName ()
	return "Spice Run"
end

function getDescription ()
	return
		"I am a humble merchant and I'm always looking for new goods to enrichen my stock. "..
		"I hear you are new in town and are looking to get into the exploration business. "..
		"Methinks you should start small and as it happens I have for you just the journey to undertake. "..
		"Go to the small island east of here and gather for me some extraordinary spices. "..
		"Not many people dare to go the island because of the bears and wolves, so prepare to defend yourself."
end

--[[
	Functions related to objectives
]]--

function getNumberOfObjectives ()
	return 1
end

function getObjectiveText(index)

	if index == 1 then
		if game:getDifficulty() == 0 then
			return "Collect 25 units of spices"
		elseif game:getDifficulty() == 1 then
			return "Collect 40 units of spices"
		elseif game:getDifficulty() == 2 then
			return "Collect 60 units of spices"
		end
	else
		return ""
	end
	
end

function getObjectiveHelpText(index)
	if index == 1 then
		return "Spices can usually be found in more in-land areas."
	else
		return ""
	end
end


function isObjectiveCompleted(index)

	if index == 1 then
	
		local spiceToCollect = 25;
		if game:getDifficulty() == 1 then
			spiceToCollect = 40
		elseif game:getDifficulty() == 2 then
			spiceToCollect = 60
		end

		-- Have we enough spices?
		if party:countResource(Items.Herbs, Herbs.Spice) >= spiceToCollect then
			return true
		end
	end
	
	return false

end

--[[
	Functions related to rewards
]]--

function getNumberOfRewards ()
	return 1
end

function getRewardText(index)

	if index == 1 then
		if game:getDifficulty() == 0 then
			return "1500 gold"
		elseif game:getDifficulty() == 1 then
			return "1000 gold"
		elseif game:getDifficulty() == 2 then
			return "500 gold"
		end
	end
	
end

function shouldAutoCollectRewards ()
	return false
end

function onComplete ()

	local spiceToCollect = 25;
	local goldReward = 1500;
	
	if game:getDifficulty() == 1 then
		spiceToCollect = 40
		goldReward = 1000
	elseif game:getDifficulty() == 2 then
		spiceToCollect = 60
		goldReward = 500
	end
	party:removeResource(Items.Herbs, Herbs.Spice, spiceToCollect);
	party:increaseTreasure(goldReward)
	
end
